#include <cxxcls/pobject.h>
#include <cxxcls/plink.h>
#include <cxxcls/linkvstr.h>

typedef enum partType
{
    Atomic,
    Composite
} PartType;

class Iterator
{
private:
    LinkVstrAny	parts;
    LinkVstrAny	block;
    o_4b	curIndex;
    o_4b	curOffset;
    o_4b	loadedOffset;

    void	load(void);

public:
    Iterator();
    ~Iterator();

    void	select(PartType, const PPredicate&);
    LinkAny	first(void);
    LinkAny	next(void);
};

inline	LinkAny
Iterator::first(void)
{
    curIndex = 0;
    return next();
}
